#ifndef GPomdp_hh
#define GPomdp_hh
// $Id: GPomdp.hh 29 2006-12-19 02:16:20Z daa $

namespace libpg {
class GPomdp : public RLAlg {

public:

    /**
     * Don't call this one directly. Tears will result.
     */
    GPomdp() {}; 


    GPomdp(Controller* controller, Simulator* simulator, double discount, double stepSize);

    virtual double learnCore(int stepsPerEpoch, int& totalSteps);
    virtual double doSteps(Vector& totalReward, int steps, bool learn);

};
}
#endif
