#ifndef CAR_HH
#define CAR_HH

int  random2();

class Car {

  Intersection* last_intersection; // needed by the GUI
  Intersection* current_intersection;
  Intersection::Direction current_incoming_direction;
  Intersection::Direction outgoing_direction;
  Intersection::Turn turn;
  Intersection* next_intersection;
  Intersection::Direction next_incoming_direction;
  int position_on_road;
  //int queue_number;
  int wait_time;
  Intersection* source;
  Intersection* destination;
  double create_time;
  double id;

  Intersection::Direction decide_next_outgoing_dir(
       std::vector<Intersection::Direction>& dirs);

public:

  Car(Intersection* the_source, Intersection* dest, double time, double the_id);
  Intersection::Turn navigate();
  void do_departure();
  bool update();
  void print_info();
  void decrease_queue_number();
  double get_id() {return id;} 
  double get_create_time() {return create_time;}
  int get_position_on_road() {return position_on_road;}
  Intersection::Turn get_turn() {return turn;}
  Intersection* get_last_intersection() {return last_intersection;}
  Intersection* get_current_intersection() {return current_intersection;}
  Intersection* get_next_intersection() {return next_intersection;}
  Intersection::Direction get_current_incoming_direction() {
    return current_incoming_direction;}
  Intersection::Direction get_next_incoming_direction() {
    return next_incoming_direction;}
};

#endif
