#ifndef CRFCircle_hh
#define CRFCircle_hh


namespace tree_mcmc {

class CRFCircle : public CRFApprox {

protected:

	int num_row;				
	int num_col;				

protected:

	virtual void alloc_adj_matrix();
	virtual void associate_edge_with_nodes();
	virtual int get_edge_id(int node1, int node2);
	virtual void define_partitions();

public:

	CRFCircle(int *argc, char** argv);

	virtual void fill_edge_reward(double *reward);

	/**
	 *	Set up the parameters, the adjacency matrix
	 */
	virtual void init_graph(int *argc, char **argv);

};

}

#endif
