// $Id$

class FixedController : public libpg::Controller {

  int current_phase;
  int duration; // how long the current phase has been on
  // (could be extracted from obs, that would be safer actually... )
  int inputs; // needed by FactoredController
  int phase_length[PHASES];

public:
   
  FixedController(int no_inputs, int NS_length,
		  int NSR_length, int EW_length, int EWR_length);

  virtual void getAction(libpg::Observation& obs, Vector& action, bool computeGrad = false);

  virtual int getInputDim();
  virtual void discountTrace() {}
  virtual void setDiscount(double discount) {}
  virtual void instantStep(Vector& reward) {}
    virtual void batchStep() {};
  virtual void setStepSize(double stepSize) {}
  virtual void resetTrace() {}
    virtual void resetGrad() {};
  virtual void resetParams();
  virtual void randomizeParams();
  virtual double getMaxParam() { return 0; }
  virtual int getNumParams() { return 0; }
  virtual void write(ostream& o);
  virtual void read(istream& o);

    virtual void reduce(Vector& v, libpg::Approximator::StatsEnum s) {};
    virtual void scatter(Vector& v, libpg::Approximator::StatsEnum s) {};
    virtual void accumulateGrad(Vector& r, libpg::Observation& newObs) {};
    virtual void computeDirection(int s) {};
};
