#include"PGBasics.hh"
#include"FixedPhaseController.hh"

using namespace libpg;

void FixedPhaseController::getAction(Observation& obs, Vector& action, 
				     bool computeGrad) {   
  assert(action.size() == 1);
  time++;
  if(time % length == 0) {
    action[0] = 1; // switch phase
    last_action = 1;
  }
  else
    action[0] = 0; // stay in last phase
}

int FixedPhaseController::getInputDim() {
    return inputs;
}

void FixedPhaseController::resetParams() { 
}

void FixedPhaseController::randomizeParams() { 
  NYI; 
}
