// $Id$

class FixedPhaseController : public libpg::Controller {

  int time;
  int last_action;
  int inputs; // needed by FactoredController
  int length;


public:
   
  FixedPhaseController(int no_inputs, int phase_length) : 
    inputs(no_inputs), length(phase_length) {time = 0; last_action = 0;}
  //virtual ~FixedPhaseController() {};

  virtual void getAction(libpg::Observation& obs, Vector& action, bool computeGrad = false);
  //virtual void getMostProbAction(libpg::Observation& obs, libpg::Vector& action);

  virtual int getInputDim();
  virtual void discountTrace() {}
  virtual void setDiscount(double discount) {}
  //virtual void accumulateGrad(double reward);
  virtual void instantStep(Vector& reward) {}
  virtual void instantStep(Vector& reward, libpg::Observation& newObs) {}
  //virtual void batchStep();
  virtual void setStepSize(double stepSize) {}
  virtual void resetTrace() {}
    virtual void resetGrad() {}
  virtual void resetParams();
  virtual void randomizeParams();
  virtual double getMaxParam() { return 0; }
  virtual int getNumParams() { return 0; }
    virtual void write(std::ostream& o) {} // empty since not useful for this controller
    virtual void read(std::istream& o) {}  // empty since not useful for this controller
};
