// $Id$

class ScatsController : public libpg::Controller {

  int inputs;
  int phase_length[PHASES];
  //int current_phase;
  //int duration;
  double statistics[PHASES];
  //int time;
  int total_phases;
  int id;
  double high_threshold;
  double low_threshold;
  bool boost;
  bool random_phases;
  int _MAX_CYCLE_LENGTH;

public:

  ScatsController(int no_inputs, int init_phase_length, 
		  double upper_threshold = 0.35, 
		  double lower_threshold = 0.15, bool sudden_changes = false,
		  bool RP = false);
  //virtual ~ScatsController() {}

  virtual void getAction(libpg::Observation& obs, Vector& action, bool computeGrad = false);

  virtual int getInputDim();
  virtual void discountTrace() {}
  virtual void setDiscount(double discount) {}
  //virtual void accumulateGrad(double reward);
  virtual void instantStep(Vector& reward) {}
  //virtual void batchStep();
  virtual void setStepSize(double stepSize) {}

  virtual void resetTrace() {}
  virtual void resetParams();
  virtual void randomizeParams();
  virtual double getMaxParam() { return 0; }
  virtual int getNumParams() { return 0; }
  virtual void write(ostream& o); 
  virtual void read(istream& o); 

  int getPolicy(int phase);
};
