#ifndef CRFOffset_hh
#define CRFOffset_hh

namespace tree_mcmc {

class CRFOffset : public CRFChain {

protected:

	int max_delay;
	int min_delay;
	int **history_action;
	int step_per_epoch;
	int sum_act_3;

public:

	CRFOffset(int *argc, char** argv);
	virtual void init_tree_sampler(int *argc, char **argv);

	void record_previous_history();

	virtual void cal_fea_expectation();
	virtual void fill_trace();
	virtual void set_potentials();
	virtual void cal_diagnosis();	
	virtual void buffer_last_action(int * actions);

	virtual void load_last_action();
	virtual char * get_diagnosis(int argc, char ** argv);

	virtual void graph_para_write(std::ostream & o);
};

}

#endif
